Index: tmp/org.txm.annotation.core/src/org/txm/annotation/AnnotationEngines.java
===================================================================
--- tmp/org.txm.annotation.core/src/org/txm/annotation/AnnotationEngines.java	(revision 0)
+++ tmp/org.txm.annotation.core/src/org/txm/annotation/AnnotationEngines.java	(revision 490)
@@ -0,0 +1,60 @@
+package org.txm.annotation;
+
+import org.eclipse.core.runtime.CoreException;
+import org.eclipse.core.runtime.IConfigurationElement;
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.Platform;
+import org.txm.Engine;
+import org.txm.EngineType;
+import org.txm.EnginesManager;
+import org.txm.Toolbox;
+
+public abstract class AnnotationEngines extends EnginesManager<AnnotationEngine> {
+	@Override
+	public boolean startEngines(IProgressMonitor monitor) {
+		
+		for (Engine e : engines.values()) {
+			AnnotationEngine se = (AnnotationEngine)e;
+			if (monitor != null) monitor.subTask("Starting "+ se.getName()+" annotation engine.");
+			se.start(monitor);
+		}
+		return true;
+	}
+
+	@Override
+	public boolean stopEngines() {
+		for (Engine e : engines.values()) {
+			AnnotationEngine se = (AnnotationEngine)e;
+			System.out.println("Stoping "+ se.getName()+" annotation engine.");
+			se.stop();
+		}
+		return true;
+	}
+
+	@Override
+	public EngineType getEnginesType() {
+		return EngineType.ANNOTATION;
+	}
+
+	@Override
+	protected boolean fetchEngines() {
+		
+		IConfigurationElement[] contributions = Platform.getExtensionRegistry().getConfigurationElementsFor(AnnotationEngine.EXTENSION_POINT_ID);
+		//System.out.println("search engine contributions: "+SearchEngine.EXTENSION_POINT_ID);
+		for (int i = 0; i < contributions.length; i++) {
+			try {
+				AnnotationEngine e = (AnnotationEngine)contributions[i].createExecutableExtension("class"); //$NON-NLS-1$
+				if (e.initialize()) {
+					engines.put(e.getName(), e);
+				} else {
+					System.out.println("Fail to initialize "+e.getName()+" annotation engine.");
+				}
+			} catch(CoreException e) {
+				System.out.println("Fail instanciate "+contributions[i].getName()+": "+e.getLocalizedMessage());
+				e.printStackTrace();
+			} 
+		}
+		
+		return engines.size() > 0;
+	}
+}

Index: tmp/org.txm.annotation.core/src/org/txm/annotation/KRAnnotationEngine.java
===================================================================
--- tmp/org.txm.annotation.core/src/org/txm/annotation/KRAnnotationEngine.java	(revision 0)
+++ tmp/org.txm.annotation.core/src/org/txm/annotation/KRAnnotationEngine.java	(revision 490)
@@ -0,0 +1,288 @@
+package org.txm.annotation;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.txm.annotation.repository.KnowledgeRepository;
+import org.txm.annotation.repository.KnowledgeRepositoryManager;
+import org.txm.annotation.repository.SQLKnowledgeRepository;
+import org.txm.objects.BaseParameters;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.MainCorpus;
+import org.txm.sql.SQLConnection;
+import org.txm.utils.logger.Log;
+import org.w3c.dom.Element;
+import org.w3c.dom.NodeList;
+
+public class KRAnnotationEngine extends AnnotationEngine {
+
+	static HashMap<MainCorpus, AnnotationManager> ams = new HashMap<MainCorpus, AnnotationManager>();
+	public static String KNOWLEDGE_ACCESS = "access";
+	public static String KNOWLEDGE_STRINGS = "strings";
+	public static String KNOWLEDGE_TYPEQUERIES = "queries";
+	public static String KNOWLEDGE_TYPES = "fields";
+	
+	public static String KNOWLEDGE_TYPEWEBACCESS = "typeaccess";
+
+	public static boolean canBeAnnotated(MainCorpus corpus) {
+		return getKnowledgeRepositoryNames(corpus).size() > 0;
+	}
+
+	public static AnnotationManager getAnnotationManager(Corpus corpus){
+		return ams.get(corpus.getMainCorpus());
+	}
+
+	public static AnnotationManager getAnnotationManager(MainCorpus corpus) {
+		AnnotationManager am = ams.get(corpus);
+		if (am == null) {
+			if (getKnowledgeRepositoryNames(corpus).size() > 0) {
+				am = new AnnotationManager(corpus);
+				ams.put(corpus, am);
+			}
+				
+		}
+		return am;
+	}
+	
+	protected static Element getKnowledgeRepositoriesElement(Element corpusElement) {
+		NodeList textsList = corpusElement.getElementsByTagName("knowledgeRepositories");
+		if (textsList.getLength() == 0) {
+			Element knowledgeRepositories = corpusElement.getOwnerDocument().createElement("knowledgeRepositories");
+			corpusElement.appendChild(knowledgeRepositories);
+			return knowledgeRepositories;
+		} else {
+			return (Element) textsList.item(0);
+		}
+	}
+
+	/**
+	 * 
+	 * Lazy load KR
+	 * 
+	 * @param name KnowledgeRepository's name
+	 * @return may return null if the KnowledgeRepository does not exist
+	 */
+	public static KnowledgeRepository getKnowledgeRepository(Corpus corpus, String name) {
+		return KnowledgeRepositoryManager.getKnowledgeRepository(name, corpus.getMainCorpus());
+	}
+
+	/**
+	 * Utility method to get a knowledge repository configuration
+	 * 
+	 * @param name the repository name
+	 * @return
+	 */
+	public static HashMap<String, HashMap<String, ?>> getKnowledgeRepositoryConfiguration(String name, Element e) {
+		HashMap<String, HashMap<String, ?>> repConfiguration = new HashMap<String, HashMap<String, ?>>();
+
+		HashMap<String, String> access = new HashMap<String, String>();
+		HashMap<String, HashMap<String, String>> strings = new HashMap<String, HashMap<String, String>>();
+		HashMap<String, HashMap<String, String>> fields = new HashMap<String, HashMap<String, String>>();
+
+		if (e == null) return null;
+
+		access.put(SQLKnowledgeRepository.NAME, e.getAttribute(SQLKnowledgeRepository.NAME));
+		access.put("version", e.getAttribute("version"));
+		access.put("mode", e.getAttribute("mode"));
+		access.put(SQLKnowledgeRepository.TYPE_URL, e.getAttribute(SQLKnowledgeRepository.TYPE_URL));
+		access.put(SQLKnowledgeRepository.TYPE_RESURL, e.getAttribute(SQLKnowledgeRepository.TYPE_RESURL));
+		access.put(SQLKnowledgeRepository.TYPE_TYPEURL, e.getAttribute(SQLKnowledgeRepository.TYPE_TYPEURL));
+		access.put(SQLConnection.SQL_ADDRESS, e.getAttribute(SQLConnection.SQL_ADDRESS));
+		access.put(SQLConnection.SQL_DRIVER, e.getAttribute(SQLConnection.SQL_DRIVER));
+		access.put(SQLConnection.SQL_PORT, e.getAttribute(SQLConnection.SQL_PORT));
+		access.put(SQLConnection.SQL_USER, e.getAttribute(SQLConnection.SQL_USER));
+		access.put(SQLConnection.SQL_PASSWORD, e.getAttribute(SQLConnection.SQL_PASSWORD));
+
+		//<type id="" name> ... </type>
+		NodeList typesList = e.getElementsByTagName("type");
+		for (int i = 0 ; i < typesList.getLength() ; i++) {
+			//<field type="xxx">yyy</field>
+			Element typeElement = (Element)typesList.item(i);
+			String type_id = ""+typeElement.getAttribute(SQLKnowledgeRepository.TYPE_ID);
+			
+			String type_name = typeElement.getAttribute(SQLKnowledgeRepository.NAME);
+			if (type_name == null || type_name.length() == 0) type_name = type_id;
+			
+			String type_url = ""+typeElement.getAttribute(SQLKnowledgeRepository.TYPE_URL);
+			
+			String type_size = typeElement.getAttribute(SQLKnowledgeRepository.TYPE_SIZE);
+			if (type_size == null || type_size.length() == 0) type_size = "SMALL"; // show all by default 
+			type_size = type_size.toUpperCase();
+			
+			String type_effect = typeElement.getAttribute(SQLKnowledgeRepository.TYPE_EFFECT);
+			if (type_effect == null || type_effect.length() == 0) type_effect = "SEGMENT"; // segment annotation by default 
+			type_effect = type_effect.toUpperCase();
+
+			HashMap<String, String> hashFields = new HashMap<String, String>();
+			NodeList fieldsList = typeElement.getElementsByTagName("field"); // contains KR type specific properties
+			for (int j = 0 ; j < fieldsList.getLength() ; j++) {
+				Element fieldElement = (Element)fieldsList.item(j);
+				hashFields.put(fieldElement.getAttribute("type"), fieldElement.getTextContent());
+			}
+
+			hashFields.put(SQLKnowledgeRepository.TYPE_URL, type_url);
+			hashFields.put(SQLKnowledgeRepository.NAME, type_name);
+			hashFields.put(SQLKnowledgeRepository.TYPE_SIZE, type_size);
+			hashFields.put(SQLKnowledgeRepository.TYPE_EFFECT, type_effect);
+			fields.put(type_id, hashFields);
+		}
+		
+		NodeList stringsList = e.getElementsByTagName("strings");
+		for (int i = 0 ; i < stringsList.getLength() ; i++) {
+			Element stringsElement = (Element)stringsList.item(i);
+			String lang = stringsElement.getAttribute("lang");
+			if (lang == null) lang = "en"; // default lang is "en"
+			
+			HashMap<String, String> values = new HashMap<String, String>();
+			strings.put(lang, values);
+			
+			NodeList stringList = stringsElement.getElementsByTagName("string");
+			for (int j = 0 ; j < stringList.getLength() ; j++) {
+				Element stringElement = (Element)stringList.item(j);
+				String key = stringElement.getAttribute("key");
+				if (key != null) {
+					values.put(key, stringElement.getTextContent());
+				}
+			}
+		}
+
+		repConfiguration.put(KNOWLEDGE_ACCESS, access);
+		repConfiguration.put(KNOWLEDGE_TYPES, fields);
+		repConfiguration.put(KNOWLEDGE_STRINGS, strings);
+		
+		return repConfiguration;
+	}
+
+	public static Element getKnowledgeRepositoryElement(BaseParameters params, String name) {
+		Element rElement = getKnowledgeRepositoriesElement(params.getCorpusElement());
+		NodeList repositoriesList = rElement.getElementsByTagName("repository");
+		for (int i = 0 ; i < repositoriesList.getLength() ; i++) {
+			Element e = ((Element)repositoriesList.item(i));
+			if (name.equals(e.getAttribute("name"))) {
+				return e;
+			}
+		}
+
+		return null;
+	}
+	
+
+	/**
+	 * Utility method to get a knowledge repository configuration
+	 * 
+	 * @param params
+	 * @return the repository names
+	 */
+	public static List<String> getKnowledgeRepositoryNames(BaseParameters params) {
+		ArrayList<String> names = new ArrayList<String>();
+		Element corpusElement = params.getCorpusElement();
+		if (corpusElement == null) return names;
+		
+		Element rElement = getKnowledgeRepositoriesElement(corpusElement);
+		if (rElement == null) return names;
+		
+		NodeList repositoriesList = rElement.getElementsByTagName("repository");
+		for (int i = 0 ; i < repositoriesList.getLength() ; i++) {
+			names.add(((Element)repositoriesList.item(i)).getAttribute("name"));
+		}
+		return names;
+	}
+	
+	/**
+	 * 
+	 * @param corpus the corpus
+	 * @return the repository names
+	 */
+	public static List<String> getKnowledgeRepositoryNames(Corpus corpus) {
+		BaseParameters params = corpus.getBase().getBaseParameters();
+		return getKnowledgeRepositoryNames(params);
+	}
+	
+	/**
+	 * 
+	 * @param corpus
+	 * @return true if there are annotations to save for this corpus
+	 */
+	public static boolean needToSaveAnnotations(MainCorpus corpus) {
+		AnnotationManager am = ams.get(corpus);
+		if (am != null) 
+			return am.hasChanges();
+		else
+			return false;
+	}
+	
+	public void closeAnnotationManager(MainCorpus corpus) {
+		AnnotationManager am = ams.get(corpus);
+		if (am != null) {
+			//System.out.println("  Closing AM...");
+			am.closeAll();
+		}
+	}
+	
+	protected Element createKnowledgeRepositoryElement(BaseParameters params, String name) {
+		Element rElement = getKnowledgeRepositoriesElement(params.getCorpusElement());
+		Element e = rElement.getOwnerDocument().createElement("repository");
+		e.setAttribute("name", name);
+		e.setAttribute("mode", "file");
+		e.setAttribute("user", "false");
+		e.setAttribute("password", "false");
+		e.setAttribute("version", "0");
+		
+		rElement.appendChild(e);
+		return e;
+	}
+	
+	@Override
+	public String getName() {
+		return "KR Annotation engine";
+	}
+
+	@Override
+	public boolean getState() {
+		return true;
+	}
+
+	@Override
+	public boolean initialize() { // nothing to load right now, the kr and am are lazy
+		return false;
+	}
+
+	@SuppressWarnings("unchecked")
+	public boolean[] mustLoginToKnowledgeRepository(Corpus corpus, String kr_name) {
+		return KnowledgeRepositoryManager.mustLoginToKnowledgeRepository(kr_name, corpus.getMainCorpus());
+	}
+
+	@Override
+	public boolean start(IProgressMonitor monitor) {
+		return true;
+	}
+
+	@Override
+	public boolean stop() {
+		boolean success = true; 
+		for (KnowledgeRepository kr : KnowledgeRepositoryManager.getKnowledgeRepositories()) {
+			try {
+				if (kr.getJPAManager().isOpen())
+					kr.getJPAManager().close();
+			} catch(Exception e) {
+				System.out.println("Error: cannot close KR "+kr+": "+e.getLocalizedMessage());
+				Log.printStackTrace(e);
+				success = false;
+			}
+		}
+		for (AnnotationManager am : ams.values()) {
+			try {
+				if (am.isOpen())
+					am.closeAll();
+			} catch(Exception e) {
+				System.out.println("Error: cannot close AM "+am+": "+e.getLocalizedMessage());
+				Log.printStackTrace(e);
+				success = false;
+			}
+		}
+		
+		return success;
+	}
+}

Index: tmp/org.txm.annotation.core/src/org/txm/annotation/repository/KnowledgeRepository.java
===================================================================
--- tmp/org.txm.annotation.core/src/org/txm/annotation/repository/KnowledgeRepository.java	(revision 489)
+++ tmp/org.txm.annotation.core/src/org/txm/annotation/repository/KnowledgeRepository.java	(revision 490)
@@ -91,6 +91,10 @@
 		// <property name="eclipselink.ddl-generation" value="drop-and-create-tables"/>
 
 		emf = new PersistenceProvider().createEntityManagerFactory(DatabasePersistenceManager.PERSISTENCE_UNIT_NAME, properties);
+		if (emf == null) {
+			System.out.println("Error: could not create the PersistenceProvider with name: "+DatabasePersistenceManager.PERSISTENCE_UNIT_NAME);
+			return null;
+		}
 		EntityManager entityManager = (EntityManager) emf.createEntityManager();
 		this.jpaem = entityManager;
 		return entityManager;
Index: tmp/org.txm.annotation.core/src/org/txm/annotation/repository/KnowledgeRepositoryManager.java
===================================================================
--- tmp/org.txm.annotation.core/src/org/txm/annotation/repository/KnowledgeRepositoryManager.java	(revision 489)
+++ tmp/org.txm.annotation.core/src/org/txm/annotation/repository/KnowledgeRepositoryManager.java	(revision 490)
@@ -4,9 +4,12 @@
 import java.util.HashMap;
 import java.util.List;
 
+import javax.persistence.EntityManager;
+
 import org.apache.commons.io.FileUtils;
 import org.txm.Toolbox;
 import org.txm.annotation.DatabasePersistenceManager;
+import org.txm.annotation.KRAnnotationEngine;
 import org.txm.core.preferences.TBXPreferences;
 import org.txm.objects.BaseParameters;
 import org.txm.sql.SQLConnection;
@@ -36,7 +39,7 @@
 	 */
 	@SuppressWarnings("unchecked")
 	public static KnowledgeRepository createKnowledgeRepository(String name, Element element) {
-		HashMap<String, HashMap<String, ?>> conf = BaseParameters.getKnowledgeRepositoryConfiguration(name, element);
+		HashMap<String, HashMap<String, ?>> conf = KRAnnotationEngine.getKnowledgeRepositoryConfiguration(name, element);
 		return createKnowledgeRepository(name, conf);
 	}
 	
@@ -52,9 +55,9 @@
 
 		//System.out.println("Creating Knowledge repository ["+name+"] with configuration="+conf);
 
-		HashMap<String, String> access = (HashMap<String, String>) conf.get(BaseParameters.KNOWLEDGE_ACCESS);
-		HashMap<String, HashMap<String, String>> fields = (HashMap<String, HashMap<String, String>>) conf.get(BaseParameters.KNOWLEDGE_TYPES);
-		HashMap<String, HashMap<String, String>> strings = (HashMap<String, HashMap<String, String>>) conf.get(BaseParameters.KNOWLEDGE_STRINGS);
+		HashMap<String, String> access = (HashMap<String, String>) conf.get(KRAnnotationEngine.KNOWLEDGE_ACCESS);
+		HashMap<String, HashMap<String, String>> fields = (HashMap<String, HashMap<String, String>>) conf.get(KRAnnotationEngine.KNOWLEDGE_TYPES);
+		HashMap<String, HashMap<String, String>> strings = (HashMap<String, HashMap<String, String>>) conf.get(KRAnnotationEngine.KNOWLEDGE_STRINGS);
 		String access_type = access.get("mode");
 		
 		KnowledgeRepository kr = null;
@@ -79,7 +82,8 @@
 			kr.setAccessProperties(access);
 			kr.setStrings(strings);
 			kr.setFieldsTypesProperties(fields);
-			kr.initializeEntityManager();
+			EntityManager em = kr.initializeEntityManager();
+			if (em == null) return null;
 			kr.buildTypesAndValues();
 		} else {
 			System.out.println("Error. KR not created.");
@@ -106,6 +110,7 @@
 			if (krconf.exists()) {
 				try {
 					kr = createKnowledgeRepository(name, DomUtils.load(krconf).getDocumentElement());
+					if (kr == null) return null;
 					repositories.put(name, kr);
 				} catch (Exception e) {
 					System.out.println("Fail to load KR from configuration file: "+krconf);
@@ -135,6 +140,7 @@
 						repositories.put(name, kr);
 					} else {
 						System.out.println("KR not created: "+name);
+						return null;
 					}
 				} catch (Exception e) {
 					System.out.println("Fail to load KR from configuration file: "+krconf);
@@ -143,7 +149,7 @@
 			}
 		}
 		
-		Element krCorpusElement = corpus.getBase().getBaseParameters().getKnowledgeRepositoryElement(name);
+		Element krCorpusElement = KRAnnotationEngine.getKnowledgeRepositoryElement(corpus.getBase().getBaseParameters(), name);
 		String sKRCorpusVersion = krCorpusElement.getAttribute("version");
 		
 		if (kr != null) {
Index: tmp/org.txm.annotation.core/src/org/txm/annotation/AnnotationEngine.java
===================================================================
--- tmp/org.txm.annotation.core/src/org/txm/annotation/AnnotationEngine.java	(revision 0)
+++ tmp/org.txm.annotation.core/src/org/txm/annotation/AnnotationEngine.java	(revision 490)
@@ -0,0 +1,11 @@
+package org.txm.annotation;
+
+import org.txm.Engine;
+
+public abstract class AnnotationEngine implements Engine {
+
+	public static final String EXTENSION_POINT_ID = AnnotationEngine.class.getCanonicalName();
+
+	@Override
+	public abstract String getName();
+}

Index: tmp/org.txm.annotation.core/src/org/txm/annotation/AnnotationManager.java
===================================================================
--- tmp/org.txm.annotation.core/src/org/txm/annotation/AnnotationManager.java	(revision 489)
+++ tmp/org.txm.annotation.core/src/org/txm/annotation/AnnotationManager.java	(revision 490)
@@ -6,11 +6,11 @@
 import java.util.HashMap;
 import java.util.List;
 
+import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.annotation.repository.AnnotationEffect;
 import org.txm.annotation.repository.AnnotationType;
 import org.txm.annotation.repository.TypedValue;
 import org.txm.annotation.storage.temporary.TemporaryAnnotationManager;
-import org.txm.functions.ProgressWatcher;
 import org.txm.searchengine.cqp.corpus.MainCorpus;
 import org.txm.searchengine.cqp.corpus.query.Match;
 import org.txm.utils.logger.Log;
@@ -76,7 +76,7 @@
 	 * @return
 	 * @throws Exception
 	 */
-	public boolean deleteAnnotations(AnnotationType type, ProgressWatcher job) throws Exception {
+	public boolean deleteAnnotations(AnnotationType type, IProgressMonitor job) throws Exception {
 		List<Annotation> temporaryAnnotations = null;
 		List<Annotation> cqpAnnotations = null;
 		try {
@@ -113,7 +113,7 @@
 		return true;
 	}
 	
-	public boolean deleteAnnotations(AnnotationType type, List<Match> matches, ProgressWatcher job) throws Exception {
+	public boolean deleteAnnotations(AnnotationType type, List<Match> matches, IProgressMonitor job) throws Exception {
 		try {
 			tempManager.getEntityManager().getTransaction().begin();
 			for (Match m : matches) {
@@ -208,7 +208,7 @@
 	 * @return
 	 */
 	public HashMap<Match,List<Annotation>> createAnnotations(AnnotationType annotSelectedType,
-			TypedValue annotSelectedTypedValue, List<Match> matches, ProgressWatcher job) {
+			TypedValue annotSelectedTypedValue, List<Match> matches, IProgressMonitor job) {
 
 		HashMap<Match,List<Annotation>> allAnnotationsThatCollides = new HashMap<Match, List<Annotation>>();
 		tempManager.getEntityManager().getTransaction().begin(); // warning
@@ -299,4 +299,8 @@
 		tempManager.close();
 		cqpManager.close();
 	}
+
+	public boolean isOpen() {
+		return tempManager.getEntityManager().isOpen();
+	}
 }
Index: tmp/org.txm.annotation.core/src/org/txm/annotation/AnnotationWriter.java
===================================================================
--- tmp/org.txm.annotation.core/src/org/txm/annotation/AnnotationWriter.java	(revision 489)
+++ tmp/org.txm.annotation.core/src/org/txm/annotation/AnnotationWriter.java	(revision 490)
@@ -34,7 +34,7 @@
 
 	public AnnotationWriter(MainCorpus corpus){
 		this.corpus = corpus;
-		defaultKR = corpus.getKnowledgeRepository(corpus.getKnowledgeRepositoryNames().get(0));
+		defaultKR = KRAnnotationEngine.getKnowledgeRepository(corpus, KRAnnotationEngine.getKnowledgeRepositoryNames(corpus).get(0));
 		types = defaultKR.getAllAnnotationTypes();
 		
 	}
@@ -196,7 +196,7 @@
 				ArrayList<Annotation> allSegmentAnnotations = new ArrayList<Annotation>();
 				ArrayList<Annotation> allTokenAnnotations = new ArrayList<Annotation>();
 
-				KnowledgeRepository defaultKR = corpus.getKnowledgeRepository(corpus.getKnowledgeRepositoryNames().get(0));
+				KnowledgeRepository defaultKR = KRAnnotationEngine.getKnowledgeRepository(corpus, KRAnnotationEngine.getKnowledgeRepositoryNames(corpus).get(0));
 				System.out.println("Using KR="+defaultKR);
 				for (Annotation a : allAnnotations) {
 					AnnotationType type = defaultKR.getType(a.getType());
Index: tmp/org.txm.annotation.core/src/org/txm/annotation/CQPAnnotationManager.java
===================================================================
--- tmp/org.txm.annotation.core/src/org/txm/annotation/CQPAnnotationManager.java	(revision 489)
+++ tmp/org.txm.annotation.core/src/org/txm/annotation/CQPAnnotationManager.java	(revision 490)
@@ -78,8 +78,8 @@
 		if (type == null) {
 			
 			// first get know annotations from corpus's KR
-			for (String kr_name : corpus.getKnowledgeRepositoryNames()) {
-				KnowledgeRepository kr = corpus.getKnowledgeRepository(kr_name);
+			for (String kr_name : KRAnnotationEngine.getKnowledgeRepositoryNames(corpus)) {
+				KnowledgeRepository kr = KRAnnotationEngine.getKnowledgeRepository(corpus, kr_name);
 				if (kr == null) continue;
 				List<AnnotationType> types = kr.getAllAnnotationTypes();
 				for (AnnotationType t : types) {
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/functions/diagnostic/Diagnostic.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/functions/diagnostic/Diagnostic.java	(revision 489)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/functions/diagnostic/Diagnostic.java	(revision 490)
@@ -43,7 +43,7 @@
 
 import org.eclipse.osgi.util.NLS;
 import org.txm.core.messages.TXMCoreMessages;
-import org.txm.functions.ProgressWatcher;
+import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.functions.TXMCommand;
 import org.txm.objects.Base;
 import org.txm.searchengine.cqp.AbstractCqiClient;
@@ -600,7 +600,7 @@
 	}
 
 	@Override
-	public boolean compute(ProgressWatcher monitor) throws Exception {
+	public boolean compute(IProgressMonitor monitor) throws Exception {
 		if (monitor != null) monitor.beginTask("Computing informations...", 3);
 		stepGeneralInfos();
 		if (monitor != null) monitor.worked(1);
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPEngine.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPEngine.java	(revision 489)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPEngine.java	(revision 490)
@@ -276,9 +276,6 @@
 		try {
 			if (cqiClient instanceof MemCqiClient) {
 				try  {
-					for (MainCorpus corpus : CorpusManager.getCorpusManager().getCorpora()) {
-						corpus.closeAnnotationManager();
-					}
 				} catch(Exception e) {}
 				for (String name : ((MemCqiClient)cqiClient).listCorpora()) {
 					((MemCqiClient)cqiClient).dropCorpus(name);
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/MainCorpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/MainCorpus.java	(revision 489)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/MainCorpus.java	(revision 490)
@@ -39,11 +39,8 @@
 import java.util.UUID;
 
 import org.txm.Toolbox;
-import org.txm.annotation.AnnotationManager;
-import org.txm.annotation.repository.KnowledgeRepository;
-import org.txm.annotation.repository.KnowledgeRepositoryManager;
 import org.txm.core.messages.TXMCoreMessages;
-import org.txm.functions.ProgressWatcher;
+import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.objects.Base;
 import org.txm.objects.BaseParameters;
 import org.txm.objects.TxmObject;
@@ -64,8 +61,6 @@
  */
 public class MainCorpus extends Corpus {
 	
-	AnnotationManager am;
-
 	private static final long serialVersionUID = 6776153557376588804L;
 
 	/**
@@ -117,7 +112,7 @@
 	 * @return true, if successful
 	 */
 	@Override
-	public boolean export(File exportzip, ProgressWatcher monitor)
+	public boolean export(File exportzip, IProgressMonitor monitor)
 	{
 		if (this.getBase() != null)
 			return this.getBase().export(exportzip, monitor);
@@ -359,7 +354,6 @@
 	 */
 	@Override
 	public boolean delete() {
-		closeAnnotationManager();
 		removeFromCWB();
 		Base b = this.getBase();
 		if (b != null) b.delete();
@@ -539,16 +533,6 @@
 	}
 
 
-	
-	public AnnotationManager getAnnotationManager() {
-		//return null;
-		if (am == null) {
-			if (this.getKnowledgeRepositoryNames().size() > 0)
-			am = new AnnotationManager(this);
-		}
-		return am;
-	}
-	
 	protected boolean modified = false;
 	public boolean isModified() { return modified; }
 	public void setIsModified(boolean b) { modified = b; }
@@ -558,56 +542,7 @@
 		else
 			return getName();
 	}
-	
-	public boolean needToSaveAnnotations() {
-		if (getAnnotationManager() != null)
-			return am.hasChanges();
-		else
-			return false;
-	}
 
-	public boolean canBeAnnotated() {
-		return getKnowledgeRepositoryNames().size() > 0;
-	}
-
-	/**
-	 * 
-	 * Lazy load KR
-	 * 
-	 * @param name KnowledgeRepository's name
-	 * @return may return null if the KnowledgeRepository does not exist
-	 */
-	public KnowledgeRepository getKnowledgeRepository(String name) {
-		return KnowledgeRepositoryManager.getKnowledgeRepository(name, this);
-		
-//		if (kr != null) return kr; // \o/
-//		
-//		BaseParameters params = this.getBase().getBaseParameters();
-//		HashMap<String, HashMap<String, ?>> conf = params.getKnowledgeRepository(name);
-//		
-//		if (conf == null) return null;
-//
-//		return KnowledgeRepositoryManager.createKnowledgeRepository(name, conf);
-	}
-
-	/**
-	 * 
-	 * @param name KnowledgeRepository's name
-	 * @return may return null if the KnowledgeRepository does not exist
-	 */
-	public List<String> getKnowledgeRepositoryNames() {
-		BaseParameters params = this.getBase().getBaseParameters();
-		return params.getKnowledgeRepositoryNames();
-	}
-
-	public void closeAnnotationManager() {
-		if (am != null) {
-			//System.out.println("  Closing AM...");
-			am.closeAll();
-		}
-	}
-
-
 	@Override
 	public String getDetails() {
 		// TODO Auto-generated method stub
Index: tmp/org.txm.searchengine.cqp.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.searchengine.cqp.core/META-INF/MANIFEST.MF	(revision 489)
+++ tmp/org.txm.searchengine.cqp.core/META-INF/MANIFEST.MF	(revision 490)
@@ -8,8 +8,7 @@
  org.txm.core;bundle-version="0.7.0",
  org.txm.searchengine.core;bundle-version="1.0.0",
  org.txm.libs.cqp;bundle-version="1.0.0",
- org.txm.utils;bundle-version="1.0.0",
- org.txm.annotation.core;bundle-version="1.0.0"
+ org.txm.utils;bundle-version="1.0.0"
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
 Bundle-ClassPath: res/,
  .
Index: tmp/org.txm.referencer.core/src/org/txm/functions/referencer/Referencer.java
===================================================================
--- tmp/org.txm.referencer.core/src/org/txm/functions/referencer/Referencer.java	(revision 489)
+++ tmp/org.txm.referencer.core/src/org/txm/functions/referencer/Referencer.java	(revision 490)
@@ -57,7 +57,7 @@
 import java.util.Map;
 
 import org.txm.core.messages.TXMCoreMessages;
-import org.txm.functions.ProgressWatcher;
+import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.functions.TXMCommand;
 import org.txm.searchengine.cqp.AbstractCqiClient;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
@@ -147,7 +147,7 @@
 	 *
 	 * @return true, if successful
 	 */
-	public boolean compute(ProgressWatcher monitor)
+	public boolean compute(IProgressMonitor monitor)
 	{
 		try {
 			if (this.parent == null || query == null || pattern == null || prop == null)
Index: tmp/org.txm.specificities.core/src/org/txm/specificities/core/functions/SpecificitesResult.java
===================================================================
--- tmp/org.txm.specificities.core/src/org/txm/specificities/core/functions/SpecificitesResult.java	(revision 489)
+++ tmp/org.txm.specificities.core/src/org/txm/specificities/core/functions/SpecificitesResult.java	(revision 490)
@@ -39,7 +39,7 @@
 
 import org.rosuda.REngine.REXPMismatchException;
 import org.rosuda.REngine.Rserve.RserveException;
-import org.txm.functions.ProgressWatcher;
+import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.functions.TXMCommand;
 import org.txm.lexicaltable.core.functions.LexicalTable;
 import org.txm.lexicaltable.core.functions.LexicalTableFactory;
@@ -130,7 +130,7 @@
 	protected double[][] selectedSpecificitiesIndex;
 	
 	
-	public boolean compute(ProgressWatcher monitor) {
+	public boolean compute(IProgressMonitor monitor) {
 		//TODO: not implemented yet. The specificitesResults should work with a LexicalTable only? if yes, then the calling commands must build it
 		return false;
 	}
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/importer/xtz/XTZImport.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/importer/xtz/XTZImport.groovy	(revision 489)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/importer/xtz/XTZImport.groovy	(revision 490)
@@ -6,7 +6,7 @@
 import java.util.Arrays;
 import java.util.Collections;
 
-import org.txm.functions.ProgressWatcher;
+import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.utils.xml.DomUtils;
 import org.txm.metadatas.Metadatas
 import org.txm.objects.BaseParameters
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/importer/xtz/ImportModule.java
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/importer/xtz/ImportModule.java	(revision 489)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/importer/xtz/ImportModule.java	(revision 490)
@@ -9,7 +9,7 @@
 
 import org.txm.Toolbox;
 import org.txm.core.preferences.TBXPreferences;
-import org.txm.functions.ProgressWatcher;
+import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.utils.xml.DomUtils;
 import org.txm.objects.BaseParameters;
 import org.txm.utils.DeleteDir;
@@ -36,9 +36,9 @@
 	public boolean updateCorpus = false;
 	public String corpusName;
 
-	ProgressWatcher monitor;
+	IProgressMonitor monitor;
 	
-	public void setMonitor(ProgressWatcher monitor) {
+	public void setMonitor(IProgressMonitor monitor) {
 		this.monitor = monitor;
 	}
 
